#ifndef MARIO_H
#define MARIO_H

#define M_SMALL 0
#define M_BIG   1

#define M_LEFT1  0
#define M_LEFT2  1
#define M_RIGHT1 2
#define M_RIGHT2 3

#define M_WALK   0
//#define M_LITTLE 1
//#define M_SWIM   2

#define MARIO_IMMUNITY_TIME 60
// 60/20 seconds = 3 seconds

#include "box.h"

typedef struct
{
	box_t p;
    int size; // small, big
    int type1; // left1 left2, right1, right2,
    int type2; // jump, down...
    int running;
} pnj;
extern pnj mario;
extern int coins;

void marioDraw();
void marioResetJump(); // resets coyote time & jump buffering (used by teleporters)
void marioMove();
void marioBigger();
void marioSmaller();

extern int global_quit;
extern int numero_frame;
extern int mario_xMax;
extern int mario_dead;
extern int mario_immunity;
extern int mario_has_bullets;
extern int last_vx_sign;

extern int mario_starMode;

#endif
